Last Comment Bug 731423 - GC: Don't do incremental GCs during V8
: GC: Don't do incremental GCs during V8
Status: RESOLVED FIXED
:
Product: Core
Classification: Components
Component: JavaScript Engine (show other bugs)
: unspecified
: x86 Mac OS X
: -- normal (vote)
: mozilla15
Assigned To: Bill McCloskey (:billm)
:
Mentors:
Depends on:
Blocks: 735099
  Show dependency treegraph
 
Reported: 2012-02-28 15:07 PST by Gregor Wagner [:gwagner]
Modified: 2012-05-24 09:31 PDT (History)
8 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
unaffected
unaffected
unaffected
-
unaffected


Attachments
patch (883 bytes, patch)
2012-05-23 13:39 PDT, Bill McCloskey (:billm)
anygregor: review+
Details | Diff | Splinter Review

Description Gregor Wagner [:gwagner] 2012-02-28 15:07:10 PST
I see a regression on splay from Aurora to Nightly from about 8350 to 6950 on my MP.
The GC log shows that the GC pause time increased from around 40ms to 60ms because of reset GCs.
Comment 1 David Mandelin [:dmandelin] 2012-03-14 19:05:05 PDT
Fixed for now by the disabling of IGC.
Comment 2 Gregor Wagner [:gwagner] 2012-05-04 10:03:22 PDT
The current scores when I enable/disable IGC in a nightly:

disabled: around 7900
enabled: around 6600
Comment 3 Bill McCloskey (:billm) 2012-05-23 13:39:04 PDT
Created attachment 626583 [details] [diff] [review]
patch

I wasn't able to reproduce the performance difference. However, we were running incremental GCs during V8, which could certainly affect performance. With this patch, all my GCs during V8 are non-incremental. It just ensures that if we hit the allocation trigger, we always do an incremental GC. We never really hit this during interactive apps, since they'll always go through the MaybeGC trigger first.
Comment 4 Gregor Wagner [:gwagner] 2012-05-23 16:06:37 PDT
(In reply to Bill McCloskey (:billm) from comment #3)
> Created attachment 626583 [details] [diff] [review]
> patch
> 
> I wasn't able to reproduce the performance difference. However, we were
> running incremental GCs during V8, which could certainly affect performance.
> With this patch, all my GCs during V8 are non-incremental. It just ensures
> that if we hit the allocation trigger, we always do an incremental GC. We
> never really hit this during interactive apps, since they'll always go
> through the MaybeGC trigger first.

Yep the performance regression is gone even without this patch. Did some allocation trigger change within the last 3 weeks?
Anyways this patch also makes sense. Maybe you should change the the summary.
Comment 5 Bill McCloskey (:billm) 2012-05-23 16:26:17 PDT
https://hg.mozilla.org/integration/mozilla-inbound/rev/95e2e6a47831

I don't know what would have changed the score. A lot has been changing lately.
Comment 6 Ed Morley [:emorley] 2012-05-24 09:31:47 PDT
https://hg.mozilla.org/mozilla-central/rev/95e2e6a47831

Note You need to log in before you can comment on or make changes to this bug.